﻿//DESCRIPTION: Add footnote separator rules at footnotes in columns
// Peter Kahrel

(function () {
	app.scriptPreferences.measurementUnit = MeasurementUnits.POINTS;
	var d = app.documents[0];
	var weight = d.footnoteOptions.ruleLineWeight;
	var width = d.footnoteOptions.ruleWidth;
	var gb, separator;
	
	//-------------------------------------------------
	
	function getFrames (f) {
		var a = [];
		for (var i = 0; i < f.length; i++) {
			if (f[i].name === 'footnotes in columns') {
				a.push (f[i]);
			}
		}
		return a;
	}

	function getRules (r) {
		var a = [];
		for (var i = 0; i < r.length; i++) {
			if (r[i].name === 'footnote separator') {
				a.push (r[i]);
			}
		}
		return a;
	}

	//-------------------------------------------------

	var frames = getFrames (d.textFrames.everyItem().getElements());
	if (frames.length === 0) {
		exit();
	}

	var rules = getRules (d.graphicLines.everyItem().getElements());
	for (var i = 0; i < rules.length; i++) {
		rules[i].remove();
	}

	for (var i = 0; i < frames.length; i++) {
		gb = frames[i].geometricBounds;
		separator = frames[i].parentPage.graphicLines.add ({
			name: 'footnote separator',
		});
		separator.strokeWeight = weight;
		separator.paths[0].entirePath = [
			[gb[1],gb[0]],
			[gb[1]+width,gb[0]],
		];
	}
}());